# This patch file was generated by NetBeans IDE
# This patch can be applied using context Tools: Apply Diff Patch action on respective folder.
# It uses platform neutral UTF-8 encoding.
# Above lines and this line are ignored by the patching process.
Index: moodle/lib/recaptchalib.php
--- moodle/lib/recaptchalib.php Base (1.12)
+++ moodle/lib/recaptchalib.php Locally Modified (Based On 1.12)
@@ -3,13 +3,13 @@
 /**
  * This is a PHP library that handles calling reCAPTCHA.
  *    - Documentation and latest version
- *          {@link http://recaptcha.net/plugins/php/}
+ *          {@link http://code.google.com/apis/recaptcha/docs/php.html}
  *    - Get a reCAPTCHA API Key
- *          {@link http://recaptcha.net/api/getkey}
+ *          {@link https://www.google.com/recaptcha/admin/create}
  *    - Discussion group
  *          {@link http://groups.google.com/group/recaptcha}
  *
- * Copyright (c) 2007 reCAPTCHA -- {@link http://recaptcha.net}
+ * Copyright (c) 2007 reCAPTCHA -- {@link http://www.google.com/recaptcha}
  * AUTHORS:
  *   Mike Crawford
  *   Ben Maurer
@@ -33,15 +33,15 @@
  * THE SOFTWARE.
  *
  * @package moodlecore
- * @copyright (c) 2007 reCAPTCHA -- {@link http://recaptcha.net}
+ * @copyright (c) 2007 reCAPTCHA -- {@link http://www.google.com/recaptcha}
  */
 
 /**
  * The reCAPTCHA server URL's
  */
-define("RECAPTCHA_API_SERVER", "http://api.recaptcha.net");
-define("RECAPTCHA_API_SECURE_SERVER", "https://api-secure.recaptcha.net");
-define("RECAPTCHA_VERIFY_SERVER", "api-verify.recaptcha.net");
+define("RECAPTCHA_API_SERVER", "http://www.google.com/recaptcha/api");
+define("RECAPTCHA_API_SECURE_SERVER", "https://www.google.com/recaptcha/api");
+define("RECAPTCHA_VERIFY_SERVER", "www.google.com");
 
 /**
  * Encodes the given data into a query string format
@@ -116,7 +116,7 @@
     $recaptchatype = optional_param('recaptcha', 'image', PARAM_TEXT);
 
     if ($pubkey == null || $pubkey == '') {
-        die ("To use reCAPTCHA you must get an API key from <a href='http://recaptcha.net/api/getkey'>http://recaptcha.net/api/getkey</a>");
+		die ("To use reCAPTCHA you must get an API key from <a href='https://www.google.com/recaptcha/admin/create'>https://www.google.com/recaptcha/admin/create</a>");
     }
 
     if ($use_ssl) {
@@ -185,7 +185,7 @@
  * A ReCaptchaResponse is returned from recaptcha_check_answer()
  *
  * @package moodlecore
- * @copyright (c) 2007 reCAPTCHA -- {@link http://recaptcha.net}
+ * @copyright (c) 2007 reCAPTCHA -- {@link http://www.google.com/recaptcha}
  */
 class ReCaptchaResponse {
         var $is_valid;
@@ -204,7 +204,7 @@
 function recaptcha_check_answer ($privkey, $remoteip, $challenge, $response, $https=false)
 {
     if ($privkey == null || $privkey == '') {
-        die ("To use reCAPTCHA you must get an API key from <a href='http://recaptcha.net/api/getkey'>http://recaptcha.net/api/getkey</a>");
+		die ("To use reCAPTCHA you must get an API key from <a href='https://www.google.com/recaptcha/admin/create'>https://www.google.com/recaptcha/admin/create</a>");
     }
 
     if ($remoteip == null || $remoteip == '') {
@@ -219,7 +219,7 @@
                 return $recaptcha_response;
         }
 
-        $response = _recaptcha_http_post(RECAPTCHA_VERIFY_SERVER, "/verify",
+        $response = _recaptcha_http_post(RECAPTCHA_VERIFY_SERVER, "/recaptcha/api/verify",
                                          array (
                                                 'privatekey' => $privkey,
                                                 'remoteip' => $remoteip,
@@ -251,7 +251,7 @@
  * @param string $appname The name of your application
  */
 function recaptcha_get_signup_url ($domain = null, $appname = null) {
-    return "http://recaptcha.net/api/getkey?" .  _recaptcha_qsencode (array ('domain' => $domain, 'app' => $appname));
+	return "https://www.google.com/recaptcha/admin/create?" .  _recaptcha_qsencode (array ('domains' => $domain, 'app' => $appname));
 }
 
 function _recaptcha_aes_pad($val) {
@@ -281,14 +281,14 @@
 function recaptcha_mailhide_url($pubkey, $privkey, $email) {
     if ($pubkey == '' || $pubkey == null || $privkey == "" || $privkey == null) {
         die ("To use reCAPTCHA Mailhide, you have to sign up for a public and private key, " .
-             "you can do so at <a href='http://mailhide.recaptcha.net/apikey'>http://mailhide.recaptcha.net/apikey</a>");
+		     "you can do so at <a href='http://www.google.com/recaptcha/mailhide/apikey'>http://www.google.com/recaptcha/mailhide/apikey</a>");
     }
 
 
     $ky = pack('H*', $privkey);
     $cryptmail = _recaptcha_aes_encrypt ($email, $ky);
 
-    return "http://mailhide.recaptcha.net/d?k=" . $pubkey . "&c=" . _recaptcha_mailhide_urlbase64 ($cryptmail);
+	return "http://www.google.com/recaptcha/mailhide/d?k=" . $pubkey . "&c=" . _recaptcha_mailhide_urlbase64 ($cryptmail);
 }
 
 /**
@@ -313,7 +313,7 @@
  * Gets html to display an email address given a public an private key.
  * to get a key, go to:
  *
- * http://mailhide.recaptcha.net/apikey
+ * http://www.google.com/recaptcha/mailhide/apikey
  */
 function recaptcha_mailhide_html($pubkey, $privkey, $email) {
     $emailparts = _recaptcha_mailhide_email_parts ($email);